<?php

/*
 =========================================================================
 |   Copyright 2006 - Andrei Dumitrache. All rights reserved.
 |    http://hogsmeade-village.com
 |
 |   This file is part of Xpression News (X-News).
 |
 |   Xpression News is free software; you can redistribute it and/or modify
 |   it under the terms of the GNU General Public License as published by
 |   the Free Software Foundation; either version 2 of the License, or
 |   (at your option) any later version.
 |
 |   Xpression News is distributed in the hope that it will be useful,
 |   but WITHOUT ANY WARRANTY; without even the implied warranty of
 |   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 |   GNU General Public License for more details.
 |
 |   You should have received a copy of the GNU General Public License
 |   along with Xpression News; if not, write to the Free Software
 |   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 |
 |   ALSO
 |
 |   [--] You are not allowed to sell or claim any part of this publication to be yours
 |   [--] You are not allowed to remove or alter our hyperlink from the files where it is
 |        included (news.php, archives.php and index.php)
 |   [--] You must agree to this license agreement to use the script in any way.
 =========================================================================
*/

require_once("functions.php");
require("config.inc.php");
require_once("skin.php");

$xout='';
$action=$_GET['xnewsaction'];
$deftemplate=GetDefaultTemplate();
if (!empty($_COOKIE['xnews-apskin'])){$template=$_COOKIE['xnews-apskin'];}
if (isset($_GET['xnews-template'])){$template=$_GET['xnews-template'];setcookie('xnews-apskin',$template);}
if (empty($template)){$template=$deftemplate;}
$xwrapper=file_get_contents($script['paths']['file']."templates/$template/content-wrapper.html");
function GetGroupedArchList()
{
 $archives=GetArchList($script['news']['sort']);
 $lasty='';
 $a=0;
 $b=0;
 if (count($archives)>0)
 {
 foreach ($archives as $i=>$archive)
 {
   $a++;
   $month=substr($archive,0,2);
   $year=substr($archive,2,4);
   if ($lasty!=$year)
   {
    $lasty=$year;
    $a=1;
   }
   $res[$year][$a]['month']=$month;
   $res[$year][$a]['year']=$year;
 }
 }
 return $res;
}


if (empty($action))
{

  if (!isset($authorlist)){$authorlist=$_GET['xnews-authorlist'];}
  if (!isset($catlist)){$catlist=$_GET['xnews-catlist'];}
  $archmonth=file_get_contents($script['paths']['file']."templates/$template/archives-month.html");
  $archyear=file_get_contents($script['paths']['file']."templates/$template/archives-year.html");
  $wrapper=file_get_contents($script['paths']['file']."templates/$template/archives-wrapper.html");
  $content='';
  $arr=GetGroupedArchList();

  if (count($arr)>0)
  {
  foreach ($arr as $i=>$item)
  {
   $block='';
   foreach ($item as $j=>$subitem)
   {
    $hlink=$_SERVER['SCRIPT_NAME'].'?xnewsaction=getnews&gogo=archives&newsarch='.$subitem['month'].$subitem['year'];
    if (isset($_GET['xnews-catlist'])){$hlink.='&xnews-catlist='.$_GET['xnews-catlist'];}
    $mtpl=str_replace("{ARCH}",MonthfromNum($subitem['month']),$archmonth);
    $mtpl=str_replace("{ARCHLINK}",$hlink,$mtpl);
    $block.=str_replace("{ARCHNUM}",NewsCount($subitem['month'].$subitem['year']),$mtpl);
   }
   $ytpl=str_replace("{MONTHS}",$block,$archyear);
   $content.=str_replace("{YEAR}",$item[1]['year'],$ytpl);
  }
  } else {$content='';}
  $wrapper=str_replace("{ARCHCONT}",$content,$wrapper);
  $xout.=$wrapper;

}
else if ($action=='getnews')
{
 $newsarch=$_GET['newsarch'];
 $newstpl= file_get_contents($script['paths']['file']."templates/$template/news-article.html");
 $news=GetNews($newsarch,$catlist,$authorlist,0,$script['news']['sort'],"");
 
  $xout.="<td><table cellspacing=3 cellpadding=0>";
 foreach ($news as $i=>$article)
 {
	 $xout.="<tr><td valign=top style='border-style: solid; border-width:1px; border-color: #F0F0F0; padding:10px;'>";
   $xout.=SkinNewsArticle($article,$newstpl);
    $xout.="</td></tr>";
 }
 $xout.="</table></td>";

  $news_wrapper=file_get_contents($script['paths']['file']."templates/$template/news-wrapper.html");
  $news_wrapper=str_replace("{NEWS}",$xout,$news_wrapper);
  $xout=$news_wrapper;

}

else if ($action=='fullnews')
{
  $newsid=$_GET['newsid'];
  $newsarch=$_GET['newsarch'];
  $article=FUllNews($newsarch,$newsid,'');
  $tpl=file_get_contents($script['paths']['file']."templates/$template/full-news-article.html");
  $c=SkinFullNewsArticle($article,$tpl);
  $xout.=$c;
}

else if ($action=='getcomments')
 {
   $range=$_GET['range'];
   if ($range==''){$range='1-25';}
   $newsid=$_GET['newsid'];
   $newsarch=$_GET['newsarch'];
   $comments=GetComments($newsarch,$newsid,$range);
   $article=FullNews($newsarch,$newsid,'');
   $wrapper=SkinCommentsPage($article,$comments,$template,$_SERVER['SCRIPT_NAME'],$range);
   $content=str_replace("{notice}",'',$wrapper);
   $xout.=$content;
   unset($content);
   unset($c);

 }
 else if ($action=='addcomment')
 {   if ($script['comments']['enabled']!="ON")
   {
    $wrapper=SkinMessage('$__msg_commentsdisabled',$template);
    $xout.=$wrapper;
   }else
   {
  // echo "hey!";
   $author=$_POST['author'];
   $email=$_POST['email'];
   $comment=$_POST['comment'];
   $newsid=$_GET['newsid'];
   $newsarch=$_GET['newsarch'];
   if (empty($author) or empty($comment) or !VerifyCaptcha() or !VerifyCommentLength())
   {
     $notice='';
     if (empty($author)){$notice='$__msg_forgotname';}
     if (empty($comment)){if ($notice==''){$notice='$__msg_forgotcomment';}else {$notice.='<BR />$__msg_forgotcomment';}}
     if (!VerifyCaptcha()){if ($notice==''){$notice='$__msg_wrongcaptcha';}else {$notice.='<BR />$__msg_wrongcaptcha';}}
     if (!VerifyCommentLength()){if ($notice==''){$notice='$__msg_longcomment';}else {$notice.='<BR />$__msg_longcomment';}}
     $comments=GetComments($newsarch,$newsid,$range);
     $article=FullNews($newsarch,$newsid,'');
     $wrapper=SkinCommentsPage($article,$comments,$template,$_SERVER['SCRIPT_NAME'],'1-25');
     $content=str_replace("{notice}",$notice,$wrapper);
     $xout.=$content;
   }
  else {
     $post=1;
     if (IsUser($author))
     {
       if ($author!=$_COOKIE['xusername']){$post=0;}
        else
        {
         if (ValidateLogin($author,$_COOKIE['xpassword'])==1)
         {
          $post=1;
         }
        else
        {
         $post=0;
        }
       }
     }
    if ($post==1)
    {
     PostComment($newsarch,$newsid,$author,$email,$comment);
     $wrapper=SkinMessage(LanguageField('msg_commentposted',''),$template);
     $wrapper=str_replace("{LINK}",$_SERVER['SCRIPT_NAME']."?xnewsaction=getcomments&newsarch=".$newsarch."&newsid=".$newsid,$wrapper);
     $xout.=$wrapper;
    } else
    {
     $xout.= SkinMessage(LanguageField('msg_requirelogin',''),$template);
     $xout=str_replace('{REGNICK}',$author,$xout);
    }
    }
  }
 }
if ($script['rss']['enabled']=="YES")
{
$feedlinkcode='<a href="'.$script['paths']['url'].'news.xml"><img src="'.$script['paths']['url'].'inc/img/rss.gif" border="0"></a>';
$feedlinkcode.='<a href="http://fusion.google.com/add?feedurl='.$script['paths']['url'].'news.xml"><img src="'.$script['paths']['url'].'inc/img/rss-google.gif" border="0"></a>';
$feedlinkcode.='<a href="http://e.my.yahoo.com/config/cstore?.opt=content&.url='.$script['paths']['url'].'news.xml"><img src="'.$script['paths']['url'].'inc/img/rss-yahoo.gif" border="0"></a>';
$xout=str_replace("{FEEDLINKS}",$feedlinkcode,$xout);
}
$xout=str_replace("{FEEDLINKS}","",$xout); 
$xwrapper=str_replace("{CONTENT}",$xout,$xwrapper);
$xout=$xwrapper;
OutputWrapper($xout,1);
unset($content,$wrapper,$action,$xout);

?>