<?php
/*
 =========================================================================
 |   Copyright 2006 - Andrei Dumitrache. All rights reserved.
 |    http://hogsmeade-village.com
 |
 |   This file is part of Xpression News (X-News).
 |
 |   Xpression News is free software; you can redistribute it and/or modify
 |   it under the terms of the GNU General Public License as published by
 |   the Free Software Foundation; either version 2 of the License, or
 |   (at your option) any later version.
 |
 |   Xpression News is distributed in the hope that it will be useful,
 |   but WITHOUT ANY WARRANTY; without even the implied warranty of
 |   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 |   GNU General Public License for more details.
 |
 |   You should have received a copy of the GNU General Public License
 |   along with Xpression News; if not, write to the Free Software
 |   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 |
 |   ALSO
 |
 |   [--] You are not allowed to sell or claim any part of this publication to be yours
 |   [--] You are not allowed to remove or alter our hyperlink from the files where it is
 |        included (news.php, archives.php and index.php)
 |   [--] You must agree to this license agreement to use the script in any way.
 =========================================================================
*/

?>

<html>

<head>
  <title>Xpression News - View Permissions</title>
<link href="inc/styles.css" rel="stylesheet" type="text/css">
</head>

<body bgcolor="#4E647E">
<?php

require("functions.php");
$rankid=$_GET['rank'];
$p=GetRankPerms($rankid);
$p=str_replace("1","YES",$p);
$p=str_replace("0","NO",$p);



?>
<div align="center">
  <table width="80%" border="0" cellspacing="1" cellpadding="0" class="tableborder">
    <tr>
      <th colspan="2" class="cat">Viewing Permissions for <?php print GetRankName($rankid);?> (rank)</th>
    </tr>
    <tr>
      <td width="40%" class="row1"> <div align="right">&nbsp;Can Post Comments:</div></td>
      <td width="60%" class="row2"><?php print $p[0];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Edit Own Comments:</div></td>
      <td class="row2"><?php print $p[1]; ?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Edit Other Comments:</div></td>
      <td class="row2"><?php print $p[2];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Post News:</div></td>
      <td class="row2"><?php print $p[3];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Edit Own News:</div></td>
      <td class="row2"><?php print $p[4];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Edit Other News:</div></td>
      <td class="row2"><?php print $p[5];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Upload Images:</div></td>
      <td class="row2"><?php print $p[6];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Delete Own Images:</div></td>
      <td class="row2"><?php print $p[7];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Delete Other Images:</div></td>
      <td class="row2"><?php print $p[8];?></td>
    </tr>
    <tr>
      <td class="row1"><div align="right">Can Administrate:</div></td>
      <td class="row2"><?php print $p[9];?></td>
    </tr>
  </table>
</div>
</body>

</html>